#ifndef PROG_KMEANS_CLUSTER_H
#define PROG_KMEANS_CLUSTER_H

#include <stdbool.h>
#include <stdlib.h>
#include "linkedlist.h"
#include "vector.h"


typedef struct cluster_int {
	vector_int_t* center;
	list_points_int_t* points;
} cluster_int_t;

typedef struct cluster_fpt {
	vector_fpt_t* center;
	list_points_fpt_t* points;
} cluster_fpt_t;


cluster_int_t* cluster_create_int(vector_int_t* center);

cluster_fpt_t* cluster_create_fpt(vector_fpt_t* center);


void cluster_destroy_int(cluster_int_t* center);

void cluster_destroy_fpt(cluster_fpt_t* center);


void cluster_add_point_int(cluster_int_t* cluster, vector_int_t* point);

void cluster_add_point_fpt(cluster_fpt_t* cluster, vector_fpt_t* point);


bool cluster_update_center_int(cluster_int_t* cluster);

bool cluster_update_center_fpt(cluster_fpt_t* cluster);


void cluster_reset_int(cluster_int_t* cluster);

void cluster_reset_fpt(cluster_fpt_t* cluster);


#endif //PROG_KMEANS_CLUSTER_H
