#include "common.h"
#include <stdbool.h>
#include <stdlib.h>
#include <time.h>


bool randinit = false;


void init_rand() {
	srand(time(NULL));
	randinit = true;
}


int rand_int(int max) {
	if (!randinit) init_rand();
	return rand() % max;
}


int rand_int_range(int min, int max) {
	if (min > max) {
		int swap = min;
		min = max;
		max = swap;
	}
	return min + rand_int(max - min);
}


double rand_double_range_one() {
	if (!randinit) init_rand();
	return ((double) rand()) / ((double) RAND_MAX);
}


double rand_double_range(double min, double max) {
	if (min > max) {
		double swap = min;
		min = max;
		max = swap;
	}
	return min + rand_double_range_one() * (max - min);
}
