#ifndef PROG_KMEANS_DISTANCE_H
#define PROG_KMEANS_DISTANCE_H

#include "vector.h"


int_t abs_diff_int(int_t a1, int_t a2);

fpt_t abs_diff_fpt(fpt_t a1, fpt_t a2);


fpt_t distance_euclid_int(const vector_int_t* p1, const vector_int_t* p2);

fpt_t distance_euclid_fpt(const vector_fpt_t* p1, const vector_fpt_t* p2);


fpt_t distance_manhattan_int(const vector_int_t* p1, const vector_int_t* p2);

fpt_t distance_manhattan_fpt(const vector_fpt_t* p1, const vector_fpt_t* p2);


fpt_t distance_chebyshev_int(const vector_int_t* p1, const vector_int_t* p2);

fpt_t distance_chebyshev_fpt(const vector_fpt_t* p1, const vector_fpt_t* p2);


#endif //PROG_KMEANS_DISTANCE_H
