#ifndef PROG_KMEANS_IO_H
#define PROG_KMEANS_IO_H

#include <stdio.h>
#include "cluster.h"
#include "common.h"
#include "linkedlist.h"
#include "vector.h"


int_t io_read_int(FILE* file);

fpt_t io_read_fpt(FILE* file);


vector_int_t* io_line_to_vector_int(char* line, const size_t dim);

vector_fpt_t* io_line_to_vector_fpt(char* line, const size_t dim);


list_points_int_t* io_get_vector_list_int(FILE* ifile, const size_t dim);

list_points_fpt_t* io_get_vector_list_fpt(FILE* ifile, const size_t dim);


void io_write_clusters_to_file_int(FILE* file, cluster_int_t** clusters, const size_t cluster_count);

void io_write_clusters_to_file_fpt(FILE* file, cluster_fpt_t** clusters, const size_t cluster_count);


#endif //PROG_KMEANS_IO_H
