#ifndef PROG_KMEANS_KMEANS_H
#define PROG_KMEANS_KMEANS_H

#include "cluster.h"
#include "linkedlist.h"


cluster_int_t** kmeans_init_clusters_int(const vector_int_t** points, const size_t point_count, const size_t nclusters);

cluster_fpt_t** kmeans_init_clusters_fpt(const vector_fpt_t** points, const size_t point_count, const size_t nclusters);


void kmeans_destroy_clusters_int(cluster_int_t** clusters, const size_t nb_clusters);

void kmeans_destroy_clusters_fpt(cluster_fpt_t** clusters, const size_t nb_clusters);


void kmeans_int(vector_int_t** points, const size_t point_count, cluster_int_t** clusters, const size_t nb_clusters, fpt_t (* distance_function)(const vector_int_t*, const vector_int_t*));

void kmeans_fpt(vector_fpt_t** points, const size_t point_count, cluster_fpt_t** clusters, const size_t nb_clusters, fpt_t (* distance_function)(const vector_fpt_t*, const vector_fpt_t*));


#endif //PROG_KMEANS_KMEANS_H
