#ifndef PROG_KMEANS_VECTOR_H
#define PROG_KMEANS_VECTOR_H

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include "common.h"


typedef struct vector_int {
	size_t dim;
	int_t* data;
} vector_int_t;


typedef struct vector_fpt {
	size_t dim;
	fpt_t* data;
} vector_fpt_t;


vector_int_t* vector_create_int(const size_t dim);

vector_fpt_t* vector_create_fpt(const size_t dim);


void vector_destroy_int(vector_int_t* vp);

void vector_destroy_fpt(vector_fpt_t* vp);


vector_int_t* vector_copy_int(const vector_int_t* v);

vector_fpt_t* vector_copy_fpt(const vector_fpt_t* v);


bool vector_equals_int(const vector_int_t* v1, const vector_int_t* v2);

bool vector_equals_fpt(const vector_fpt_t* v1, const vector_fpt_t* v2);


void vector_print_to_file_int(FILE* file, const vector_int_t* v);

void vector_print_to_file_fpt(FILE* file, const vector_fpt_t* v);


void vector_add_inplace_int(vector_int_t* v, const vector_int_t a);

void vector_add_inplace_fpt(vector_fpt_t* v, const vector_fpt_t a);


void vector_div_inplace_int(vector_int_t* v, const int_t a);

void vector_div_inplace_fpt(vector_fpt_t* v, const fpt_t a);


void vector_print_int(const vector_int_t* v);

void vector_print_fpt(const vector_fpt_t* v);


#endif //PROG_KMEANS_VECTOR_H
